import { mongo } from 'mongoose';
import { FileLogInitType, S3FileState } from '../enums/s3.enum';

export interface IS3 {
    key: string;
    bucket: string;
    etag: string;
}

export interface ILogInitiator {
    type: FileLogInitType;
    name: string;
}

export interface IS3File {
    id: mongo.ObjectId;
    fileMeta: IFileMeta;
    state: IFileState;
    s3: IS3;
    record: IFileRecord;
    owner: string;
}

export interface IFileState {
    value: S3FileState;
    log: IFileLog[];
}

export interface IFileRecord {
    createdAt: Date;
    updatedAt: Date;
}

export interface IFileMeta {
    name: string;
    size: number;
    mimeType: string;
    extension: string;
}

export interface IFileLog {
    createdAt: Date;
    value: S3FileState;
    initiator: ILogInitiator;
}

export interface IFileEmbedded {
    id: string;
    name: string;
    size: number;
    mimeType: string;
    s3: IS3;
    state: S3FileState;
    createdAt: Date;
}
