import { Prop, SchemaFactory } from '@nestjs/mongoose';
import { IBase } from '../interfaces/base.interface';
import { Record, RecordSchema } from './embedded/record.embedded';
import { HydratedDocument } from 'mongoose';
import { IRecord } from '../interfaces/record.interface';
import { Identifable } from './identifable.schema';

export class Base extends Identifable implements IBase {
    @Prop({
        required: true,
        type: RecordSchema,
        default: () => {
            return new Record();
        },
    })
    record: IRecord;
}

export const BaseSchema = SchemaFactory.createForClass(Base);
export type BaseDocument = HydratedDocument<Base>;
