import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument } from 'mongoose';
import { Identifable } from '../identifable.schema';
import { IStudentEmbedded } from '../../interfaces/student-embedded.interface';
import { IParent } from '../../interfaces/parent.interface';
import { IPerson } from '../../interfaces/person.interface';
import { IDictionary } from '../../interfaces/dictionary.interface';
import { DictionaryEmbeddedSchema } from './dictionary-embedded.schema';
import { PersonSchema } from './person.schema';
import { ParentSchema } from '../parent.schema';

@Schema({ _id: false })
export class StudentEmbedded extends Identifable implements IStudentEmbedded {
    @Prop({ required: false, type: String })
    description: string;

    @Prop({ type: ParentSchema, required: true })
    parent: IParent;

    @Prop({ type: PersonSchema, required: true })
    person: IPerson;

    @Prop({ type: DictionaryEmbeddedSchema, required: true })
    knowladgeLevel: IDictionary;
}

export const StudentEmbeddedSchema = SchemaFactory.createForClass(StudentEmbedded);
export type StudentEmbeddedDocument = HydratedDocument<StudentEmbedded>;
