import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument, Schema as MongooseSchema, Types } from 'mongoose';
import { IParent } from '../interfaces/parent.interface';
import { IContact } from '../interfaces/contact.interface';
import { IPerson } from '../interfaces/person.interface';
import { ContactSchema } from './embedded/contact.schema';
import { PersonSchema } from './embedded/person.schema';

@Schema({ _id: false })
export class Parent implements IParent {
    @Prop({ required: true, type: MongooseSchema.Types.ObjectId })
    userId: string;

    @Prop({ type: PersonSchema, required: true })
    person: IPerson;

    @Prop({ type: [ContactSchema], required: true, default: [] })
    contacts: IContact[];
}

export const ParentSchema = SchemaFactory.createForClass(Parent);
export type ParentDocument = HydratedDocument<Parent>;
